function chart(reporting) {
    "use strict";

    var model = openerp;

    reporting.ReportChartWidget = reporting.Base.extend({
        BuildLineChart: function (label,data,CurrencyBase) {
            var self = this;
            Chart.scaleService.updateScaleDefaults('linear', {
                ticks: {
                    callback: function(tick) {
                        return tick.toLocaleString('de-DE');
                    }
                }
            });
            Chart.defaults.global.tooltips.callbacks.label = function(tooltipItem, data) {
                var dataset = data.datasets[tooltipItem.datasetIndex];
                var datasetLabel = dataset.label || '';
                return datasetLabel +  dataset.data[tooltipItem.index].toLocaleString('de-DE');
            };
            var chart = new Chart($(".reporting-chart"), {
                type: 'line',
                data: {
                    labels: label,
                    datasets: [
                        {
                            label: false,
                            data: data,
                            backgroundColor: '#bbdefb',
                            borderColor: '#0288d1',
                            borderWidth: 1,
                            fill: true,
                        }
                    ]
                },
                options: {
                    responsive: true,
                    responsiveAnimationDuration:10,
                    maintainAspectRatio:false,
                    title: {
                        display: false,
                    },
                    hover: {
                        mode: 'nearest',
                        intersect: true
                    },
                    legend: {
                       display: false,
                    },
                    layout: {
                        padding: {
                            top: 0,
                            bottom: 0,
                            left : 0,
                            rigth: 0,
                        }
                    },
                    events: ['click'],
                    tooltips: {
                        callbacks: {
                            label: function(tooltipItem, data) {
                                var label = data.datasets[tooltipItem.datasetIndex].label || '';

                                if (label) {
                                    label += ': ';
                                }
                                label += accounting.formatMoney(tooltipItem.yLabel, CurrencyBase.symbol, CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator);
                                return label;
                            }
                        }
                    }
                }
            });
        },
        fetchBarChart: function (data,CurrencyBase,label,body) {
            var self = this;
            var rank = 10;
            var item;
            // var label = [];
            // var body = [];
            //
            // for (var i = 0; i < rank; i++) {
            //     if (data[i]){
            //         item = data[i];
            //     }else{
            //         item = {};
            //         item.product = "N/A";
            //         item.amount = 0;
            //     }
            //     label.push(item.product.trim());
            //     body.push(item.amount);;
            // }

            Chart.scaleService.updateScaleDefaults('linear', {
              ticks: {
                callback: function(tick) {
                    return tick.toLocaleString('de-DE');
                }
              }
            });
            Chart.defaults.global.tooltips.callbacks.label = function(tooltipItem, data) {
                var dataset = data.datasets[tooltipItem.datasetIndex];
                var datasetLabel = dataset.label || '';
                return datasetLabel +  dataset.data[tooltipItem.index].toLocaleString('de-DE');
            };

            var coloR = [];
            coloR.push('#1976d2');
            coloR.push('#e53935');
            coloR.push('#9575cd');
            coloR.push('#009688');
            coloR.push('#43a047');
            coloR.push('#cddc39');
            coloR.push('#f9a825');
            coloR.push('#ff5722');
            coloR.push('#6d4c41');
            coloR.push('#ffff00');

            var chart = new Chart($(".reporting-chart"), {
                type: 'horizontalBar',
                data: {
                    labels: label,
                    datasets: [
                        {
                            label: false,
                            data: body,
                            backgroundColor: coloR,
                            fill: true,
                        }
                    ]
                },
                options: {
                    responsive: true,
                    responsiveAnimationDuration:10,
                    maintainAspectRatio:false,
                    title: {
                        display: false,
                    },
                    hover: {
                        mode: 'nearest',
                        intersect: true
                    },
                    legend: {
                       display: false,
                    },
                    layout: {
                        padding: {
                            top: 0,
                            bottom: 0,
                            left : 0,
                            rigth: 0,
                        }
                    },
                    tooltips: {
                        callbacks: {
                            label: function(tooltipItem, data) {
                                var label = data.datasets[tooltipItem.datasetIndex].label || '';

                                if (label) {
                                    label += ': ';
                                }
                                label += accounting.formatMoney(tooltipItem.xLabel, CurrencyBase.symbol, CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator);
                                return label;
                            }
                        }
                    },
                    events: ['click'],
                }
            });
        },
        fetchPieChart: function (data,CurrencyBase,label,body) {
            var self = this;
            // var rank = 9;
            // var item;
            // var label = [];
            // var body = [];
            //
            // var amount_total = _.reduce(_.map(data, function (map) {
            //     return map.amount
            // }), function (meno,num) {
            //     return meno + num
            // }, 0);
            //
            // for (var i = 0; i < rank; i++) {
            //     if (data[i]){
            //         item = data[i];
            //     }else{
            //         item = {};
            //         item.product = "N/A";
            //         item.amount = 0;
            //     }
            //     label.push(item.product.trim());
            //     body.push((item.amount/amount_total)*100);
            // }
            //
            // var num = 0;
            // for (var i = 9; i < data.length; i++) {
            //     num += data[i].amount;
            // }
            //
            // if(num > 0){
            //     label.push('Otros productos');
            //     body.push((num/amount_total)*100);
            // }

            var coloR = [];
            coloR.push('#1976d2');
            coloR.push('#e53935');
            coloR.push('#9575cd');
            coloR.push('#009688');
            coloR.push('#43a047');
            coloR.push('#cddc39');
            coloR.push('#f9a825');
            coloR.push('#ff5722');
            coloR.push('#6d4c41');
            coloR.push('#ffff00');

            var chart = new Chart($(".reporting-pie-chart"), {
                type: 'pie',
                data: {
                    labels: label,
                    datasets: [
                        {
                            label: false,
                            data: body,
                            backgroundColor: coloR,
                            fill: true,
                        }
                    ]
                },

                options: {
                    responsive: true,
                    responsiveAnimationDuration:10,
                    maintainAspectRatio:false,
                    hover: {
                        mode: 'nearest',
                        intersect: true
                    },
                    legend: {
                       position: 'right',
                    },
                    layout: {
                        padding: {
                            top: 0,
                            bottom: 0,
                            left : 0,
                            rigth: 0,
                        }
                    },
                    tooltips: {
                        callbacks: {
                            label: function(tooltipItem, data) {
                                var label = data.datasets[tooltipItem.datasetIndex].label || '';
                                if (label) {
                                    label += ': ';
                                }
                                label += accounting.formatMoney(data.datasets[0].data[tooltipItem.index],{
                                    symbol: "%",
                                    format: "%v%s",
                                    precision: 2,
                                    thousand: ".",
                                    decimal: ","
                                });
                                return label;
                            }
                        }
                    },
                    events: ['click'],
                }
            });
        },
    });
}
